;
; ### Keyboard Lock by JM v 1.14 ###
;
; - Created 900126 by JM -
;
;
; This program locks up the keyboard and mouse when both shift keys are
; pressed simultaneously.  A password is needed to make the keyboard and
; mouse work again.
;
; The password is given on the command line as RAW KEY codes (in hexa-
; decimal notation).
;
; The main program Wait()s for a SIGBREAK_CTRL_C (CTRL+C) and exits when
; the signal is received.  Lock can be started with background run and it
; will not crash even without an output file handle.
;
;
;
; Bugs: yet unknown
;
;
; Edited:
;
; - 900126 by JM -> v0.00	- Needs lotsa work.
; - 900128 by JM -> v0.01	- Major footsteps taken - tttopf4h!
; - 900129 by JM -> v0.02	- Preliminary handler written.
; - 900129 by JM -> v0.03	- It works.
;				  Who knows what the password is? ;-)
; - 900129 by JM,TM -> v0.90	- Password now taken from the command line.
; - 900129 by JM -> v1.00	- A few bytes crunched off.
; - 900130 by JM -> v1.10	- DisplayBeep() added.  Now beeps when the
;				  lock is closed or opened.
;				- Prints an error message if can't install.
; - 900212 by JM -> v1.11	- hstuff moved into the bss hunk.
; - 900212 by JM -> v1.12	- Some compressing done again.
;				- Comments improved.
; - 900220 by JM -> v1.13	- A bug fix: Corrupted memory location 0.L.
; - 900301 by JM -> v1.14	- A bug fix: Passed key-ups even if locked.
;
;



		include	"exec.xref"
		include	"dos.xref"
		include	"intuition.xref"
		include	"JMPLibs.i"
		include	"relative.i"
		include	"com.i"
		include	"exec/types.i"
		include	"exec/nodes.i"
		include	"exec/lists.i"
		include	"exec/ports.i"
		include	"exec/memory.i"
		include	"exec/devices.i"
		include	"exec/io.i"
		include	"exec/tasks.i"
		include	"exec/interrupts.i"
		include	"devices/input.i"
		include	"devices/inputevent.i"
		include	"dos.i"


*
* Define a structure to hold the password and some other variables.
* These values are used by the input handler.

	STRUCTURE hdata,0
	 UWORD	hd_cnt			char counter for password
	 UWORD	hd_lock			locked flag, locked if <> 0
	 STRUCT	hd_passw,34		space for password (34 bytes)
	 APTR	hd_task			main task pointer
	LABEL	hd_SIZE


RELATIVE	equ	1

		.var			allocates variables from stack
		dl	cmdline
		dl	_DosBase,_IntuitionBase
		dl	iderror
		dl	sigbit
		dl	ioreq		pointer to struct IOReq
		dl	msgport		pointer to struct MsgPort
		dl	passw		pointer to password buffer


start		.begin				LINK a4,#-NN
		clr.b	-1(a0,d0.l)		add NULL
		move.l	a0,cmdline(a4)		save command line pointer

* set variables to known states:
		moveq.l	#-1,d0			preset error flags
		move.l	d0,iderror(a4)
		move.l	d0,sigbit(a4)
		clr.l	_DosBase(a4)		clear DosBase
		clr.l	_IntuitionBase(a4)	clear IntuitionBase

* set structure pointers:
		lea	IORequest,a0		   address of IORequest
		move.l	a0,ioreq(a4)
		lea	(MsgPort-IORequest)(a0),a0 address of MsgPort
		move.l	a0,msgport(a4)
		lea	(Password-MsgPort)(a0),a0  address of Password
		move.l	a0,passw(a4)
		clr.l	(a0)			   reset char cnt, lock flag
		lea	(hstuff-Password)(a0),a5   address of hstuff

* open the libraries needed:
		openlib	Dos,cleanup		open dos.library
		openlib	Intuition,error		open intuition.library

* print a message on screen:
		lea	MESSAGE(pc),a2		print initial message
		bsr	sout

* get a password from command line:
		bsr	getpw			get password from command line
		bcs	cleanup			error -> exit

* open input.device:
		lea	indevname(pc),a0	"input.device"
		moveq.l	#0,d0			unit#
		move.l	ioreq(a4),a1		IoReq
		moveq.l	#0,d1			flags
		lib	Exec,OpenDevice
		move.l	d0,iderror(a4)		flag: error if > 0
		bne	error			if error

* setup a message port:
		move.l	msgport(a4),a2
		move.b	#NT_MSGPORT,LN_TYPE(a2)	msgport.mp_Node.ln_Type = 4
		clr.b	MP_FLAGS(a2)		msgport.mp_Flags = 0
		clr.l	LN_NAME(a2)		no name
		moveq.l	#-1,d0
		flib	Exec,AllocSignal	get a signal bit
		move.l	d0,sigbit(a4)
		bmi	error
		move.b	d0,MP_SIGBIT(a2)	msgport.mp_SigBit = d0

* find this process:
		sub.l	a1,a1
		flib	Exec,FindTask		find this task
		move.l	d0,MP_SIGTASK(a2)	set msgport.mp_SigTask
		move.l	passw(a4),a0
		move.l	d0,hd_task(a0)		set task ptr for handler
		lea	MP_MSGLIST(a2),a0
		NEWLIST	a0			this IS needed
		move.l	ioreq(a4),a1		request into a1
		move.l	a2,MN_REPLYPORT(a1)	ioreq.io_Message.mn_ReplyPort

* install input handler:
		move.b	#NT_INTERRUPT,LN_TYPE(a5)  set node type
		move.b	#120,LN_PRI(a5)		set node priority
		lea	handler(pc),a2
		move.l	a2,IS_CODE(a5)		set handler code pointer
		move.l	passw(a4),IS_DATA(a5)	set handler data pointer
;		move.l	ioreq(a4),a1
		move.w	#IND_ADDHANDLER,IO_COMMAND(a1)
		move.l	a5,IO_DATA(a1)		request still in a1
		flib	Exec,DoIO		add handler
		tst.l	d0
		bne.s	error

* main loop (not a busy loop tho):

main_lp		moveq	#0,d0			wait for a CTRL + C / D
		bset	#SIGBREAKB_CTRL_C,d0
		bset	#SIGBREAKB_CTRL_D,d0
		lib	Exec,Wait
		btst	#SIGBREAKB_CTRL_D,d0	CTRL + D ?
		beq.s	stopped			nope -> asked to stop

		sub.l	a0,a0			CTRL + D -> DisplayBeep()
		lib	Intuition,DisplayBeep
		bra.s	main_lp			return to Wait()

* error exit:

error		lea	ERMSG(pc),a2
		bsr.s	sout
		bra.s	cleanup

* jumps here when asked to stop:

stopped		move.l	ioreq(a4),a1		remove input handler
		move.w	#IND_REMHANDLER,IO_COMMAND(a1)
		move.l	a5,IO_DATA(a1)		addr of hstuff
		flib	Exec,DoIO		remove handler
		tst.l	d0
		bne.s	cleanup

		lea	REMOVED(pc),a2		inform the user
		bsr.s	sout

* cleanup routine:

cleanup		move.l	iderror(a4),d0		test if input.device open
		bne.s	cleanup10
		move.l	ioreq(a4),a1
		lib	Exec,CloseDevice	close input.device

cleanup10	move.l	sigbit(a4),d0		test if a signal allocated
		bmi.s	cleanup11
		lib	Exec,FreeSignal		if so, free it

cleanup11	closlib	Intuition		close intuition.library
		closlib	Dos			close dos.library
		moveq.l	#0,d0
		.end				UNLK and RTS



*************************************************************************
*									*
* Output a string pointed to by a2.  The first byte must contain the	*
* string length.  If output file handle is NULL  (no printing is	*
* possible) sout will do nothing.					*
*									*
*************************************************************************

sout		lib	Dos,Output
		move.l	d1,d0			file*
		beq.s	sout_q			no file -> do not print
		moveq	#0,d3			length
		move.b	(a2)+,d3
		move.l	a2,d2
		flib	Dos,Write
sout_q		rts



*************************************************************************
*									*
* Get the password string:						*
*									*
*************************************************************************

getpw		;get password:
		move.l	cmdline(a4),a0		command line pointer
		move.l	passw(a4),a1		output buffer pointer
		lea	hd_passw(a1),a1		skip counter and lock flag
		moveq	#31,d2			length of output
getpw1		move.b	(a0),d1			get character
		beq.s	getpw0			eol? end if so
		cmp.b	#32,d1			space?
		beq.s	getpw0			end if so
		cmp.b	#9,d1			tab?
		beq.s	getpw0			end if so
		bsr.s	gxc			get high nibble
		bcs.s	getpwx			error? exit if so
		move.b	d1,d0			save
		asl.b	#4,d0			and shift
		bsr.s	gxc			get low nibble
		bcs.s	getpwx			error? exit if so
		or.b	d1,d0			concatenate
		move.b	d0,(a1)+		and output
		cmp.b	#',',(a0)		comma present?
		dbeq	d2,getpw1		no, continue if still room
		bne.s	getpwx			no more room, error exit
		addq.w	#1,a0			skip comma
		dbf	d2,getpw1		and continue if room
getpwx		;error exit point:
		lea.l	USAGE(pc),a2		text pointer
		bsr	sout			print it
		setc	;			and return carry
		rts
getpw0		;normal exit point:
		st	(a1)			put -1 at end
		subq	#hd_passw,a1
		cmp.l	passw(a4),a1		empty password?
		beq.s	getpwx			yep -> error
		clrc	;			return no carry
		rts

gxc		;get hex nibble into d1:
		move.b	(a0)+,d1		get character
		cmp.b	#'a',d1			lower case?
		blo.s	gxc1
		sub.b	#32,d1			convert to capital
gxc1		sub.b	#'0',d1			subtract minimum
		blo.s	gxcx			lower? error if so
		cmp.b	#9,d1			numeric?
		bls.s	gxc2			return if so
		cmp.b	#22,d1			higher than 'F'?
		bhi.s	gxcx			error if so
		sub.b	#17,d1			subtract 'A'
		blo.s	gxcx			lower? error if so
		add.b	#10,d1			and convert to 10..15
gxc2		;normal exit point:
		clrc	;			return no carry
		rts
gxcx		;error exit point:
		setc	;			return carry
		rts


*************************************************************************
*									*
* My input handler routine.  It doesn't handle a linked list of input	*
* events correctly because it only checks the first event of the list.	*
* If the first one is a fkey the rest of the events in the queue are	*
* discarded.  If the first event is not a fkey the list is passed	*
* untouched to the next handler (ie. no later events are checked for	*
* fkey codes).								*
*									*
*************************************************************************

handler		push	d1-d3/a1-a2/a6		save registers
		move.l	a0,a2			start of the list
		move.w	hd_lock(a1),d3		get onld lock state
handler_lp	move.b	ie_Class(a0),d2		class into d2
		cmpi.b	#IECLASS_RAWKEY,d2	rawkay?
		beq.s	handler_what		yes ->see what to do
		cmpi.b	#IECLASS_RAWMOUSE,d2	mousemove?
		bne.s	handex			no -> skip this event

handler_what	moveq.l	#IEQUALIFIER_LSHIFT!IEQUALIFIER_RSHIFT,d0 mask
		move.l	d0,d1
		and.w	ie_Qualifier(a0),d1	check qualifier field
		cmp.w	d0,d1			both shift keys down?
		beq.s	handler_lock		yes -> lock the keyboard

		tst.w	hd_lock(a1)		test if locked
		bne.s	handler_open

handex		move.l	ie_NextEvent(a0),d0	get next event
		move.l	d0,a0
		bne.s	handler_lp		handle all events in list

handex_ok	cmp.w	hd_lock(a1),d3		signal to main proc needed?
		beq.s	handex_nosig		no -> skip
		move.l	hd_task(a1),a1		get task pointer
		move.l	#SIGBREAKF_CTRL_D,d0	set signal bit into d0
		lib	Exec,Signal		...and post the signal
handex_nosig	move.l	a2,d0			return the orig. event list
		pull	d1-d3/a1-a2/a6		restore registers
		rts

handler_err	moveq.l	#0,d1			reset local char counter
		move.w	#1,hd_cnt(a1)		preset counter to 1 char
		cmp.b	hd_passw(a1),d0		compare with 1st char
		beq.s	handler_more

handler_lock	st	hd_lock(a1)		set flag: locked
		clr.w	hd_cnt(a1)		clear char cnt
		move.b	#IECLASS_NULL,ie_Class(a0)
		bra.s	handex_ok

handler_open	cmpi.b	#IECLASS_RAWMOUSE,d2
		beq.s	handler_nopass		eat mouse events
		move.w	ie_Code(a0),d0
		cmp.w	#$80,d0			do not care about key ups
		bhs.s	handler_nopass
		move.w	hd_cnt(a1),d1		get char counter
		addq.w	#1,hd_cnt(a1)		increment char counter
		cmp.b	hd_passw(a1,d1.w),d0	compare this char
		bne.s	handler_err		error -> reset counter

handler_more	cmp.b	#-1,(hd_passw+1)(a1,d1.w)	chars left?
		bne.s	handler_nopass		yup -> don't pass event
		clr.w	hd_lock(a1)		open lock
handler_nopass	move.b	#IECLASS_NULL,ie_Class(a0)
		bra.s	handex


*************************************************************************
*									*
* ASCII strings needed by this program.					*
*									*
*************************************************************************

indevname	dc.b	'input.device',0
MESSAGE		dc.b	42,'KeyLock 1.14 by Supervisor Software 1990',10
REMOVED		dc.b	13,'Lock removed',10
ERMSG		dc.b	15,'Cannot install',10
USAGE		dc.b	26,'Usage: keylock <password>',10


*************************************************************************
*									*
* This macro produces only the dos.library name in this program.	*
*									*
*************************************************************************

		libnames


*************************************************************************
*									*
* Structures defined in a bss chunk to make the program file smaller.	*
*									*
*************************************************************************

		section	struct,bss

IORequest	ds.b	IO_SIZE			space for struct IOStdReq
MsgPort		ds.b	MP_SIZE			space for struct MsgPort
Password	ds.b	hd_SIZE			space for our own structure
hstuff		ds.b	IS_SIZE			space for struct Interrupt
		end


